diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/desktop.c vnc_unixsrc/vncviewer/desktop.c
--- vnc_unixsrc.orig/vncviewer/desktop.c	2004-05-28 13:29:29.000000000 -0400
+++ vnc_unixsrc/vncviewer/desktop.c	2010-02-25 22:32:49.000000000 -0500
@@ -28,28 +28,497 @@
 #include <X11/extensions/XShm.h>
 #endif
 
+#include <X11/cursorfont.h>
+
 GC gc;
 GC srcGC, dstGC; /* used for debugging copyrect */
 Window desktopWin;
-Cursor dotCursor;
+Cursor dotCursor3 = None;
+Cursor dotCursor4 = None;
+Cursor bogoCursor = None;
+Cursor waitCursor = None;
 Widget form, viewport, desktop;
 
+int appshare_0_hint = -10000;
+int appshare_x_hint = -10000;
+int appshare_y_hint = -10000;
+
 static Bool modifierPressed[256];
 
-static XImage *image = NULL;
+XImage *image = NULL;
+XImage *image_ycrop = NULL;
+XImage *image_scale = NULL;
+
+int image_is_shm = 0;
 
 static Cursor CreateDotCursor();
 static void CopyBGR233ToScreen(CARD8 *buf, int x, int y, int width,int height);
 static void HandleBasicDesktopEvent(Widget w, XtPointer ptr, XEvent *ev,
 				    Boolean *cont);
 
+static void CopyBGR565ToScreen(CARD16 *buf, int x, int y, int width,int height);
+
 static XtResource desktopBackingStoreResources[] = {
   {
-    XtNbackingStore, XtCBackingStore, XtRBackingStore, sizeof(int), 0,
-    XtRImmediate, (XtPointer) Always,
+	XtNbackingStore, XtCBackingStore, XtRBackingStore, sizeof(int), 0,
+	XtRImmediate, (XtPointer) Always,
   },
 };
 
+double scale_factor_x = 0.0;
+double scale_factor_y = 0.0;
+int scale_x = 0, scale_y = 0;
+int scale_round(int len, double fac);
+
+double last_rescale = 0.0;
+double last_fullscreen = 0.0;
+double start_time = 0.0;
+
+int prev_fb_width = -1;
+int prev_fb_height = -1;
+
+void get_scale_values(double *fx, double *fy) {
+	char *s = appData.scale;
+	double f, frac_x = -1.0, frac_y = -1.0;
+	int n, m;
+	int xmax = si.framebufferWidth;
+	int ymax = si.framebufferHeight;
+
+	if (appData.yCrop > 0) {
+		ymax = appData.yCrop;
+	}
+
+	if (sscanf(s, "%d/%d", &n, &m) == 2) {
+		if (m == 0) {
+			frac_x = 1.0;
+		} else {
+			frac_x = ((double) n) / ((double) m);
+		}
+	}
+	if (sscanf(s, "%dx%d", &n, &m) == 2) {
+		frac_x = ((double) n) / ((double) xmax);
+		frac_y = ((double) m) / ((double) ymax);
+	}
+	if (!strcasecmp(s, "fit")) {
+		frac_x = ((double) dpyWidth)  / ((double) xmax);
+		frac_y = ((double) dpyHeight) / ((double) ymax);
+	}
+	if (!strcasecmp(s, "auto")) {
+		Dimension w, h;
+		XtVaGetValues(toplevel, XtNheight, &h, XtNwidth, &w, NULL);
+		fprintf(stderr, "auto: %dx%d\n", w, h);
+		if (w > 32 && h > 32) {
+			frac_x = ((double) w) / ((double) xmax);
+			frac_y = ((double) h) / ((double) ymax);
+		}
+	}
+	if (frac_x < 0.0 && sscanf(s, "%lf", &f) == 1) {
+		if (f > 0.0) {
+			frac_x = f;
+		}
+	}
+
+	if (frac_y < 0.0) {
+		frac_y = frac_x;
+	}
+
+	if (frac_y > 0.0 && frac_x > 0.0) {
+		if (fx != NULL) {
+			*fx = frac_x;
+		}
+		if (fy != NULL) {
+			*fy = frac_y;
+		}
+	} else {
+		if (appData.scale) {
+			fprintf(stderr, "Invalid scale string: '%s'\n", appData.scale); 
+		} else {
+			fprintf(stderr, "Invalid scale string.\n"); 
+		}
+		appData.scale = NULL;
+	}
+}
+
+void try_create_image(void);
+void put_image(int src_x, int src_y, int dst_x, int dst_y, int width, int height, int solid);
+void create_image();
+
+/* toplevel -> form -> viewport -> desktop */
+
+void adjust_Xt_win(int w, int h) {
+	int x, y, dw, dh, h0 = h;
+	int mw = w, mh = h;
+	int autoscale = 0;
+
+	if (!appData.fullScreen && appData.scale != NULL && !strcmp(appData.scale, "auto")) {
+		autoscale = 1;
+		mw = dpyWidth;
+		mh = dpyHeight;
+	}
+
+	if (appData.yCrop > 0) {
+		int ycrop = appData.yCrop; 
+		if (image_scale && scale_factor_y > 0.0) {
+			ycrop = scale_round(ycrop, scale_factor_y);
+			if (!autoscale) {
+				mh = ycrop;
+			}
+		}
+		XtVaSetValues(toplevel, XtNmaxWidth, mw, XtNmaxHeight, mh, XtNwidth, w, XtNheight, ycrop, NULL);
+		XtVaSetValues(form,     XtNmaxWidth, mw, XtNmaxHeight, mh, XtNwidth, w, XtNheight, ycrop, NULL);
+		h0 = ycrop;
+	} else {
+		XtVaSetValues(toplevel, XtNmaxWidth, mw, XtNmaxHeight, mh, XtNwidth, w, XtNheight, h, NULL);
+	}
+
+	fprintf(stderr, "adjust_Xt_win: %dx%d & %dx%d\n", w, h, w, h0);
+
+	XtVaSetValues(desktop,  XtNwidth, w, XtNheight, h, NULL);
+
+	XtResizeWidget(desktop, w, h, 0);
+
+	if (!autoscale) {
+		dw = appData.wmDecorationWidth;
+		dh = appData.wmDecorationHeight;
+
+		x = (dpyWidth  - w  - dw)/2;
+		y = (dpyHeight - h0 - dh)/2;
+
+		XtConfigureWidget(toplevel, x + dw, y + dh, w, h0, 0);
+	}
+}
+
+void rescale_image(void) {
+	double frac_x, frac_y; 
+	int w, h;
+
+	if (image == NULL) {
+		create_image();
+		return;
+	}
+
+	if (appData.useXserverBackingStore) {
+		create_image();
+		return;
+	}
+
+	if (image == NULL && image_scale == NULL) {
+		create_image();
+		return;
+	}
+
+	if (appData.scale == NULL) {
+		/* switching to not scaled */
+		frac_x = frac_y = 1.0;
+	} else {
+		get_scale_values(&frac_x, &frac_y);
+		if (frac_x < 0.0 || frac_y < 0.0) {
+			create_image();
+			return;
+		}
+	}
+
+	last_rescale = dnow();
+
+	SoftCursorLockArea(0, 0, si.framebufferWidth, si.framebufferHeight);
+
+	if (image_scale == NULL) {
+		/* switching from not scaled */
+		int i;
+		int Bpl = image->bytes_per_line;
+		char *dst, *src = image->data;
+
+		image_scale = XCreateImage(dpy, vis, visdepth, ZPixmap, 0, NULL,
+		    si.framebufferWidth, si.framebufferHeight, BitmapPad(dpy), 0);
+
+		image_scale->data = (char *) malloc(image_scale->bytes_per_line * image_scale->height);
+
+		fprintf(stderr, "rescale_image: switching from not scaled. created image_scale %dx%d\n", image_scale->width, image_scale->height);
+		fprintf(stderr, "rescale_image: copying image -> image_scale %dx%d -> %dx%d\n", image->width, image->height, image_scale->width, image_scale->height);
+
+		dst = image_scale->data;
+
+		/* copy from image->data */
+		for (i=0; i < image->height; i++) {
+			memcpy(dst, src, Bpl);
+			dst += Bpl;
+			src += Bpl;
+		}
+	}
+
+	/* now destroy image */
+	if (image && image->data) {
+		if (UsingShm()) {
+			ShmDetach();
+		}
+		XDestroyImage(image);
+		fprintf(stderr, "rescale_image: destroyed 'image'\n");
+		if (UsingShm()) {
+			ShmCleanup();
+		}
+		image = NULL;
+	}
+	if (image_ycrop && image_ycrop->data) {
+		XDestroyImage(image_ycrop);
+		fprintf(stderr, "rescale_image: destroyed 'image_ycrop'\n");
+		image_ycrop = NULL;
+	}
+
+	if (frac_x == 1.0 && frac_y == 1.0) {
+		/* switching to not scaled */
+		fprintf(stderr, "rescale_image: switching to not scaled.\n");
+		w = si.framebufferWidth;
+		h = si.framebufferHeight;
+
+		scale_factor_x = 0.0;
+		scale_factor_y = 0.0;
+		scale_x = 0;
+		scale_y = 0;
+	} else {
+		w = scale_round(si.framebufferWidth,  frac_x);
+		h = scale_round(si.framebufferHeight, frac_y);
+
+		scale_factor_x = frac_x;
+		scale_factor_y = frac_y;
+		scale_x = w;
+		scale_y = h;
+	}
+
+	adjust_Xt_win(w, h);
+
+	fprintf(stderr, "rescale: %dx%d  %.4f %.4f\n", w, h, scale_factor_x, scale_factor_y);
+
+	try_create_image();
+
+	if (image && image->data && image_scale && frac_x == 1.0 && frac_y == 1.0) {
+		/* switched to not scaled */
+		int i;
+		int Bpl = image->bytes_per_line;
+		char *dst = image->data;
+		char *src = image_scale->data;
+
+		fprintf(stderr, "rescale_image: switching to not scaled.\n");
+
+		for (i=0; i < image->height; i++) {
+			memcpy(dst, src, Bpl);
+			dst += Bpl;
+			src += Bpl;
+		}
+		XDestroyImage(image_scale);
+		fprintf(stderr, "rescale_image: destroyed 'image_scale'\n");
+		image_scale = NULL;
+	}
+
+	if (appData.yCrop > 0) {
+		int ycrop = appData.yCrop;
+		/* do the top part first so they can see it earlier */
+		put_image(0, 0, 0, 0, si.framebufferWidth, ycrop, 0);
+		if (si.framebufferHeight > ycrop) {
+			/* this is a big fb and so will take a long time */
+			if (waitCursor != None) {
+				XDefineCursor(dpy, desktopWin, waitCursor);
+				XSync(dpy, False);
+			}
+			put_image(0, 0, 0, 0, si.framebufferWidth, si.framebufferHeight - ycrop, 0);
+			if (waitCursor != None) {
+				Xcursors(1);
+				if (appData.useX11Cursor) {
+					XSetWindowAttributes attr;
+					unsigned long valuemask = 0;
+					if (appData.viewOnly) {
+						attr.cursor = dotCursor4;    
+					} else {
+						attr.cursor = dotCursor3;    
+					}
+					valuemask |= CWCursor;
+					XChangeWindowAttributes(dpy, desktopWin, valuemask, &attr);
+				}
+			}
+		}
+	} else {
+		put_image(0, 0, 0, 0, si.framebufferWidth, si.framebufferHeight, 0);
+	}
+
+	SoftCursorUnlockScreen();
+
+	fprintf(stderr, "rescale: image_scale=%p image=%p image_ycrop=%p\n", (void *) image_scale, (void *) image, (void *) image_ycrop);
+	last_rescale = dnow();
+
+}
+
+void try_create_image(void) {
+	
+	image_is_shm = 0;
+	if (appData.useShm) {
+#ifdef MITSHM
+		image = CreateShmImage(0);
+		if (!image) {
+			if (appData.yCrop > 0) {
+				if (appData.scale != NULL && scale_x > 0) {
+					;
+				} else {
+					image_ycrop = CreateShmImage(1);
+					if (!image_ycrop) {
+						appData.useShm = False;
+					} else {
+						fprintf(stderr, "created smaller image_ycrop shm image: %dx%d\n",
+						    image_ycrop->width, image_ycrop->height);
+					}
+				}
+			} else {
+				appData.useShm = False;
+			}
+		} else {
+			image_is_shm = 1;
+			fprintf(stderr, "created shm image: %dx%d\n", image->width, image->height);
+		}
+#endif
+	}
+
+	if (!image) {
+		fprintf(stderr, "try_create_image: shm image create fail: image == NULL\n");
+		if (scale_x > 0) {
+			image = XCreateImage(dpy, vis, visdepth, ZPixmap, 0, NULL,
+			    scale_x, scale_y, BitmapPad(dpy), 0);
+		} else {
+			image = XCreateImage(dpy, vis, visdepth, ZPixmap, 0, NULL,
+			    si.framebufferWidth, si.framebufferHeight, BitmapPad(dpy), 0);
+		}
+
+		image->data = malloc(image->bytes_per_line * image->height);
+
+		if (!image->data) {
+			fprintf(stderr, "try_create_image: malloc failed\n");
+			exit(1);
+		} else {
+			fprintf(stderr, "try_create_image: created *non-shm* image: %dx%d\n", image->width, image->height);
+		}
+	}
+	fprintf(stderr, "try_create_image: image->bytes_per_line: %d\n", image->bytes_per_line);
+}
+
+void create_image() {
+	image = NULL;
+	image_ycrop = NULL;
+	image_scale = NULL;
+
+	fprintf(stderr, "create_image()\n");
+
+	if (CreateShmImage(-1) == NULL) {
+		appData.useShm = False;
+	}
+	if (appData.scale != NULL) {
+		if (appData.useXserverBackingStore) {
+			fprintf(stderr, "Cannot scale when using X11 backingstore.\n");
+		} else {
+			double frac_x = -1.0, frac_y = -1.0;
+
+			get_scale_values(&frac_x, &frac_y);
+
+			if (frac_x < 0.0 || frac_y < 0.0) {
+				fprintf(stderr, "Cannot figure out scale factor!\n");
+				goto bork;
+			}
+
+			scale_factor_x = 0.0;
+			scale_factor_y = 0.0;
+			scale_x = 0;
+			scale_y = 0;
+
+
+			if (1) {
+				int w, h, hyc;
+
+				w = scale_round(si.framebufferWidth,  frac_x);
+				h = scale_round(si.framebufferHeight, frac_y);
+				hyc = h;
+				if (appData.yCrop > 0) {
+					hyc = scale_round(appData.yCrop, frac_y);
+				}
+
+				/* image scale is full framebuffer */
+				image_scale = XCreateImage(dpy, vis, visdepth, ZPixmap, 0, NULL,
+				    si.framebufferWidth, si.framebufferHeight, BitmapPad(dpy), 0);
+
+				image_scale->data = (char *) malloc(image_scale->bytes_per_line * image_scale->height);
+
+				fprintf(stderr, "create_image: created image_scale %dx%d\n", image_scale->width, image_scale->height);
+
+				if (!image_scale->data) {
+					fprintf(stderr, "create_image: malloc failed\n");
+					XDestroyImage(image_scale);
+					fprintf(stderr, "create_image: destroyed 'image_scale'\n");
+					image_scale = NULL;
+				} else {
+					int h2;
+					scale_factor_x = frac_x;
+					scale_factor_y = frac_y;
+					scale_x = w;
+					scale_y = h;
+
+					XtVaSetValues(toplevel, XtNmaxWidth, w, XtNmaxHeight, hyc, NULL);
+
+					h2 = scale_round(si.framebufferHeight, frac_y);
+					XtVaSetValues(desktop,  XtNwidth, w, XtNheight, h2, NULL);
+
+				}
+				fprintf(stderr, "create_image: scale: %dx%d  %.4f %.4f\n", w, h,
+				    scale_factor_x, scale_factor_y);
+			}
+		}
+	}
+	bork:
+	try_create_image();
+}
+
+int old_width = 0;
+int old_height = 0;
+
+int guessCrop(void) {
+	int w = si.framebufferWidth;
+
+	if (w == 320) {
+		return 240;
+	} else if (w == 400) {
+		return 300;
+	} else if (w == 640) {
+		return 480;
+	} else if (w == 800) {
+		return 600;
+	} else if (w == 1024) {
+		return 768;
+	} else if (w == 1152) {
+		return 864;
+	} else if (w == 1280) {
+		return 1024;
+	} else if (w == 1440) {
+		return 900;
+	} else if (w == 1600) {
+		return 1200;
+	} else if (w == 1680) {
+		return 1050;
+	} else if (w == 1920) {
+		return 1200;
+	} else {
+		int h = (3 * w) / 4;
+		return h;
+	}
+}
+
+void check_tall(void) {
+	if (appData.appShare) {
+		return;
+	}
+	if (! appData.yCrop) {
+		int w = si.framebufferWidth;
+		int h = si.framebufferHeight;
+		if (h > 2 * w) {
+			fprintf(stderr, "Tall display (%dx%d) suspect 'x11vnc -ncache' mode,\n", w, h);
+			fprintf(stderr, "  setting auto -ycrop detection.\n");
+			appData.yCrop = -1;
+		}
+	}
+}
 
 /*
  * DesktopInitBeforeRealization creates the "desktop" widget and the viewport
